package com.mortals.xhx.module.matter.web;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.common.key.ParamKey;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.matter.model.MatterDatumEntity;
import com.mortals.xhx.module.matter.service.MatterDatumService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import com.alibaba.fastjson.JSONObject;
import java.util.Arrays;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import static com.mortals.framework.ap.SysConstains.*;
/**
*
* 事项申请材料
*
* @author zxfei
* @date 2022-09-27
*/
@RestController
@RequestMapping("matter/datum")
public class MatterDatumController extends BaseCRUDJsonBodyMappingController<MatterDatumService,MatterDatumEntity,Long> {

    @Autowired
    private ParamService paramService;

    public MatterDatumController(){
        super.setModuleDesc( "事项申请材料");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "source", paramService.getParamBySecondOrganize("MatterDatum","source"));
        this.addDict(model, "isRecommend", paramService.getParamBySecondOrganize("MatterDatum","isRecommend"));
        super.init(model, context);
    }

    @Override
    protected int doListAfter(MatterDatumEntity query, Map<String, Object> model, Context context) throws AppException {
        int recommendCount = paramService.getParamIntValue(ParamKey.MATTER_DATUM_RECOMMEND_COUNT);
        model.put("recommendCount", recommendCount);
        return 1;
    }

    @RequestMapping(value = {"recommend"},method = {RequestMethod.POST, RequestMethod.GET})
    public String recommend(Long id) {
        Context context = this.getContext();
        Map<String, Object> model = new HashMap();
        int code = 1;
        String busiDesc = "推荐or取消推荐" + this.getModuleDesc();
        try {
            this.service.recommend(id);
            model.put("message_info", this.getModuleDesc() + "推荐or取消推荐成功!");
            this.recordSysLog(this.request, busiDesc + " 【成功】 [id:" + id + "]");
        } catch (Exception var7) {
            code = -1;
            this.doException(this.request, busiDesc, model, var7);
        }

        JSONObject ret = new JSONObject();
        ret.put("code", Integer.valueOf(code));
        ret.put("msg", model.remove("message_info"));
        ret.put("data", model);
        return ret.toJSONString();
    }
}